#ifndef Haptic_h
#define Haptic_h

#include <string>
#include <HD/hd.h>
#include <HDU/hduError.h>
#include <HDU/hduVector.h>
#include <process.h>
#include <windows.h>

//#using <mscorlib.dll>
//using namespace System;
//using namespace System::Threading;

#define HD_POSITION 0
#define HD_VELOCITY 1
#define HD_FORCE 2
#define HD_BUTTON_1 3
#define R_POSITION 4
#define R_INIT_POSITION 5
#define R_VELOCITY 6
#define dirX 0
#define	dirY 2
#define dirZ 1

struct DeviceDisplayState
{
	HDdouble position[3];
	HDdouble velocity[3];
	HDdouble force[3];
	HDdouble Rposition[3];
	HDdouble RinitPosition[3];
	HDdouble Rvelocity[3];
	HDboolean button1State;
};

struct RobInfo
{
	HDdouble initPos[3];
	HDdouble realPos[3];
};

// Function declaration
HDCallbackCode HDCALLBACK GetDeviceStateCallback(void *pUserData);
//HDCallbackCode HDCALLBACK ForceRenderCallback(void *pUserData);
//hduVector3D <HDdouble> calculateForce(void *pUserData);
//HDCallbackCode HDCALLBACK HapticLoopCallback(void *pUserData);

// Mutex protected system variables
class SystemParameters
{		
	public:
		void read(void *pUserData);
		void write(int state, void *pUserData);

	private:
		HDdouble HDposition[3];
		HDdouble HDvelocity[3];
		HDdouble HDforce[3];
		HDdouble Rposition[3];
		HDdouble RinitPosition[3];
		HDdouble Rvelocity[3];
		HDboolean HDbutton1State;
	
};



#endif
