// HapticGuidance.cpp : Defines the entry point for the console application.
//
#include "HapticGuidance.h"


HDSchedulerHandle gCallbackHandle = 0;
HDboolean iStop=0;
HANDLE SysMutex;

int main()
{	
	//Mutex for sysParameters
	SysMutex = CreateMutex(0, false, 0);

	// sinus paremeters
	double A=0.3; //amplitude
    double w=3; //frequency
	float tini, tfin, tr; //times
	char ResFile[100];
	int testNum = 1;
	double Pos[3];
	double PosContrGain[3];
	Pos[dirZ]=-50;
	Pos[dirY]=0;
	PosContrGain[dirZ] = 0.4;
	PosContrGain[dirY] = 0.5;
	double lastPosZ;
	double Xmax = 0;
	double Xmin = 0;
	double Ymax = 0;
	double Ymin = 0;
	double Zmax = 0;
	double Zmin = 0;

	// Variables of the haptic
	int keypress;
	boolean run = true;
	boolean firstTime = true;
	RobInfo robot;
	DeviceDisplayState hapState;
	SystemParameters sysParam;
	hapState.force[dirX] = 0;
	hapState.force[dirY] = 0;
	hapState.force[dirX] = 0;
	sysParam.write(HD_FORCE, &hapState);

	hduVector3D <HDdouble> force;

	//*** Init Haptic ***
	HHD hHD = hdInitDevice(HD_DEFAULT_DEVICE);    
	// 
	gCallbackHandle = hdScheduleAsynchronous(GetDeviceStateCallback, &sysParam, HD_MAX_SCHEDULER_PRIORITY);

    // Enable forces
    hdEnable(HD_FORCE_OUTPUT);

	// Start the servo scheduler
	hdStartScheduler();

	
	while(run)
	{
		firstTime = true;
		if(_kbhit())
		{
			keypress = _getch();
			if(keypress == 'Q'||keypress =='q')
			{
				run = false;
				break;
			}
		}
		if(firstTime)
		{
			GetDeviceStateCallback(&sysParam);
			sysParam.read(&hapState);
			lastPosZ = hapState.position[dirZ];
			iStop = hapState.button1State;
			if(iStop)
			{
				firstTime = false;
			}
		}
		tini = GetTickCount();
		while(iStop)
		{
			//sleep(10);
			tfin = GetTickCount();
			tr=(tfin-tini)/1000;
			
			hapState.force[dirX] = A*sin(w*tr);
			sysParam.write(HD_FORCE, &hapState);
			sysParam.read(&hapState);
			//hapState.force[dirY] = 0;
			//hapState.force[dirZ] = 0;

			//GetDeviceStateCallback(&hapState);
			sprintf(ResFile, "Results/res%i.m",testNum);
			FILE *stream1;
			stream1 = fopen(ResFile,"a");
			fprintf(stream1, "%f %f %f %f %f %f %f %f %f %f; \n", tr, hapState.force[0], hapState.force[dirZ], hapState.force[2], hapState.position[0], hapState.position[dirZ], hapState.position[2], hapState.velocity[0], hapState.velocity[dirZ], hapState.velocity[2]);
			fclose(stream1);
			
			printf("here\n");
			if(lastPosZ-hapState.position[dirZ]>1)
			{
				hapState.position[dirZ]=lastPosZ;
			}
			else if(lastPosZ-hapState.position[dirZ]<-1)
			{
				hapState.position[dirZ]=lastPosZ;
			}
			else
			{
				lastPosZ=hapState.position[dirZ];
			}

			//Position controller Z-dir
			hapState.force[dirZ]= (Pos[dirZ]-hapState.position[dirZ])*PosContrGain[dirZ];
			if(hapState.force[dirZ]<-3)
			{
				hapState.force[dirZ]=-3;
			}
			else if(hapState.force[dirZ]>3)
			{
				hapState.force[dirZ]=3;
			}
			sysParam.write(HD_FORCE, &hapState);

			//Position controller Y-dir
			hapState.force[2]= (Pos[2]-hapState.position[2])*PosContrGain[dirY];
			if(hapState.force[2]<-3)
			{
				hapState.force[2]=-3;
			}
			else if(hapState.force[2]>3)
			{
				hapState.force[2]=3;
			}
			sysParam.write(HD_FORCE, &hapState);

			// Finner yttergrenser
			/*if(hapState.position[0]>Xmax)
			{
				Xmax = hapState.position[0];
			}
			else if(hapState.position[0]<Xmin)
			{
				Xmin = hapState.position[0];
			}
			if(hapState.position[1]>Ymax)
			{
				Ymax = hapState.position[1];
			}
			else if(hapState.position[1]<Ymin)
			{
				Ymin = hapState.position[1];
			}
			if(hapState.position[2]>Zmax)
			{
				Zmax = hapState.position[2];
			}
			else if(hapState.position[2]<Zmin)
			{
				Zmin = hapState.position[2];
			}*/


			//iStop = hapState.button1State;
			if(_kbhit())
			{
				keypress = _getch();
				if(keypress == 'Q'||keypress =='q')
				{
					/*stream1 = fopen(ResFile,"a");
					fprintf(stream1, "%f %f %f %f %f %f; \n", Xmax, Xmin, Ymax, Ymin, Zmax, Zmin);
					fclose(stream1);
					*/	
					run = false;
					break;
				}
			}
		}
		//firstTime = true;
	}
	
	hdStopScheduler();
    hdUnschedule(gCallbackHandle);
    hdDisableDevice(hHD);

	return 0;
}


void SystemParameters::write(int state, void *pUserData)
{
	DeviceDisplayState* temp= (DeviceDisplayState *) pUserData;
	WaitForSingleObject(SysMutex,1000);
	switch(state)
	{
		case 0: // Writes to private HDposition variable
		{
			memcpy(&HDposition,&temp->position, sizeof(temp->position));
	
			break;
		}
		case 1: // Writes to private HDvelocity variable
		{
			memcpy(&HDvelocity,&temp->velocity, sizeof(temp->velocity));

			break;
		}
		case 2: // Writes to private HDforce variable
		{
			memcpy(&HDforce,&temp->force, sizeof(temp->force));

			break;
		}
		case 3: // Writes to private HDbutton1State variable
		{
			memcpy(&HDbutton1State,&temp->button1State, sizeof(temp->button1State));

			break;
		}
		case 4: // Writes to private Rposition variable
		{
			memcpy(&Rposition,&temp->Rposition, sizeof(temp->Rposition));

			break;
		}
		case 5: // Writes to private RinitPosition variable
		{
			memcpy(&RinitPosition,&temp->RinitPosition, sizeof(temp->RinitPosition));

			break;
		}
		case 6: // Writes to private Rvelocity variable
		{
			memcpy(&Rvelocity,&temp->Rvelocity, sizeof(temp->Rvelocity));

			break;
		}
		default:
		{
			break;
		}
	}
	ReleaseMutex(SysMutex);
}

void SystemParameters::read(void *pUserData)
{
	DeviceDisplayState* temp= (DeviceDisplayState *) pUserData;
	
	WaitForSingleObject(SysMutex,1000);
	
	memcpy(&temp->position,&HDposition, sizeof(HDposition));
	memcpy(&temp->velocity,&HDvelocity, sizeof(HDvelocity));
	memcpy(&temp->force,&HDforce, sizeof(HDforce));
	memcpy(&temp->RinitPosition,&RinitPosition, sizeof(RinitPosition));
	memcpy(&temp->Rposition,&Rposition, sizeof(Rposition));
	memcpy(&temp->button1State,&HDbutton1State, sizeof(HDbutton1State));
	
	ReleaseMutex(SysMutex);
}